var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

/*
 * This file is part of the nivo project.
 *
 * Copyright 2016-present, Raphaël Benitte.
 *
 * For the full copyright and license information, please view the LICENSE
 * file that was distributed with this source code.
 */

/**
 * @param {object}   _root
 * @param {boolean}  leavesOnly
 * @param {function} treemap
 * @param {function} getIdentity,
 * @param {function} getColor
 */
export var computeTreeMap = function computeTreeMap(_ref) {
  var _root = _ref.root,
      leavesOnly = _ref.leavesOnly,
      treemap = _ref.treemap,
      getIdentity = _ref.getIdentity,
      getColor = _ref.getColor;

  var root = treemap(_root);

  var nodes = leavesOnly ? root.leaves() : root.descendants();

  return nodes.map(function (d) {
    d.color = getColor(_extends({}, d.data, { depth: d.depth }));

    d.data.color = d.color;
    d.data.key = d.ancestors().map(function (a) {
      return getIdentity(a.data);
    }).join('.');

    return d;
  });
};